#include <gtk/gtk.h>

typedef struct {
  GtkWidget *win;
  GtkWidget *vBox;
  GtkWidget *bt_show_diag;
  GtkWidget *lab_value;
}WinData;

void get_value_dialog(GtkButton* btn, gpointer uData){
  WinData* uWData = uData;
  GtkWidget* entVal;
  GtkWidget* diagArea;
  //création de la boite de dialogue
  GtkWidget * diag = gtk_dialog_new_with_buttons("Saisir une valeur",
						 GTK_WINDOW(uWData->win),
						 GTK_DIALOG_MODAL | GTK_DIALOG_DESTROY_WITH_PARENT,
						 "OK", GTK_RESPONSE_ACCEPT,
						 "Annuler", GTK_RESPONSE_CANCEL,
						 NULL);

  //récupérer le container de la boite de dialogue
  diagArea = gtk_dialog_get_content_area (GTK_DIALOG (diag));
  gtk_container_set_border_width (GTK_CONTAINER (diagArea), 10);
  
  //créer d'un champs de saisie 
  entVal = gtk_entry_new();

  //ajouter le champs de saisie à boite de dialogue
  gtk_container_add (GTK_CONTAINER (diagArea), entVal);
  
  //aficher les éléments de la boite de dialogue
  gtk_widget_show_all (diag);

  // Affciher la boite de dialogue et récupérer la valeur du bouton 
  gint res = gtk_dialog_run(GTK_DIALOG(diag));

  const gchar* val;
  switch(res){
  case GTK_RESPONSE_ACCEPT:
    //récupérer la valeur sasise par l'utilisateur dans la boite de dialogue
    val = gtk_entry_get_text(GTK_ENTRY(entVal));
    //affecter cette valeur au label dans la fenetre principale
    gtk_label_set_text(GTK_LABEL(uWData->lab_value), val);
    break;
  case GTK_RESPONSE_CANCEL:
  case GTK_RESPONSE_NONE:
    break;
  }
  gtk_widget_destroy(diag);
}

int main (int argc, char *argv[]){
  WinData wData;
  gtk_init(&argc, &argv);
  
  //Création de la fenêtre
  wData.win = gtk_window_new(GTK_WINDOW_TOPLEVEL);
  gtk_container_set_border_width (GTK_CONTAINER (wData.win), 10);
  g_signal_connect (G_OBJECT(wData.win),"delete_event",G_CALLBACK(gtk_main_quit) ,NULL);

  //création d'un conteneur vertical
  wData.vBox = gtk_box_new(GTK_ORIENTATION_VERTICAL, 10);
  gtk_container_add(GTK_CONTAINER(wData.win),wData.vBox);

  //création du bouton et du label 
  wData.bt_show_diag = gtk_button_new_with_label("Afficher Dialogue");
  g_signal_connect (G_OBJECT(wData.bt_show_diag),"clicked",G_CALLBACK(get_value_dialog) ,&wData);
  gtk_box_pack_start (GTK_BOX(wData.vBox), wData.bt_show_diag, TRUE, TRUE, 0);
  wData.lab_value = gtk_label_new("Vide");
  gtk_box_pack_start (GTK_BOX(wData.vBox), wData.lab_value, TRUE, TRUE, 0);

  //afficher tous les éléments de win pou réviter de les afficher un par un
  gtk_widget_show_all(wData.win);
  gtk_main();
}
